<template>
  <section id="forgot-password">
    <div class="container-fluid forgot-password-bg">
      <div class="row full-height-vh m-0 d-flex align-items-center justify-content-center">
        <div class="col-md-7 col-sm-12">
          <div class="card">
            <div class="card-content">
              <div class="card-body fg-image">
                <div class="row m-0">
                  <div class="col-lg-6 d-none d-lg-block text-center py-2">
                    <img src="/app-assets/img/gallery/forgot.png" alt="" class="img-fluid" width="300" height="230">
                  </div>
                  <div class="col-lg-6 col-md-12 bg-white px-4 pt-3">
                    <h4 class="mb-2 card-title">Recover Password</h4>
                    <p class="card-text mb-3">
                      Please enter your email address and we'll send you
                      instructions on how to reset your password.
                    </p>
                      
                    <input id="email-mask" v-model="email" type="text" class="form-control mb-3" placeholder="Email" required>
                    <vue-recaptcha ref="recaptcha" :sitekey="captchaKey" class="mb-2" @verify="onVerify"/>
                    <div><strong>{{ forgotForm.pleaseTickRecaptchaMessage }}</strong></div>
                      
                    <div class="fg-actions d-flex justify-content-between">
                      <div class="login-btn">
                        <button class="btn btn-outline-primary">
                          <nuxt-link to="/form" class="text-decoration-none">
                            Back To Login
                          </nuxt-link>
                        </button>
                      </div>
                      <div class="recover-pass">
                        <button class="btn btn-primary" @click.prevent="checkIfRecaptchaVerified">
                          Recover
                        </button>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
<script>
  import _ from 'lodash'
  import to from 'await-to-js'
  import VueRecaptcha from 'vue-recaptcha'
  import Swal from 'sweetalert2'
  export default {
    layout: 'clean',
    components: {
      VueRecaptcha,
      Swal
    },
    data() {
      return {
        email: '',
        parameter: '',
        captchaKey: '6LfCB4UUAAAAAN0pP5vzLnRNdRlQPCRMZLxGtKB9',
        forgotForm: {
          recaptchaVerified: false,
          pleaseTickRecaptchaMessage: ''
        }
      }
    },
    head() {
      return {
        script: [
          {
            src:
              'https://www.google.com/recaptcha/api.js?onload=vueRecaptchaApiLoaded&render=explicit',
            async: true,
            defer: true
          }
        ]
      }
    },

    mounted() {
      this.parameter = this.$route.query.forgot
    },
    methods: {
      onVerify: function(response) {
        console.log('Verify: ' + response)
        this.forgotForm.pleaseTickRecaptchaMessage = ''
        this.forgotForm.recaptchaVerified = true
      },
      async checkIfRecaptchaVerified(evt) {
        evt.preventDefault()
        if (!this.forgotForm.recaptchaVerified) {
          this.forgotForm.pleaseTickRecaptchaMessage = 'Please tick recaptcha.'
          return true // prevent form from submitting
        }
        if (this.parameter == 'Password') {
          let [err, email] = await to(
            this.$axios.$put(
              `/api/userInfos/request/passwordReset?email=${this.email}`,
              this.email
            )
          )

          if (err || !email) {
            Swal.fire('Error!', 'Please Input valid Email Address', 'error')
            console.log(err)
          } else {
            Swal.fire(
              'Success!',
              'Check your email account for verification',
              'success'
            )
          }
        } else {
          let [errUser, user] = await to(
            this.$axios.$get(
              `/api/userInfos/request/userName?email=${this.email}`,
              this.email
            )
          )
          if (errUser || !user) {
            Swal.fire('Error!', 'Please Input valid Email Address', 'error')
            console.log(errUser)
          } else {
            Swal.fire(
              'Success!',
              'Check your email account for verification',
              'success'
            )
          }
        }
      }
    }
  }
</script>
